matrix world;
matrix view;
matrix proj;
Texture2D tex;

SamplerState smp
{
   Filter = MIN_MAG_MIP_POINT;
   AddressU = Border;
   AddressV = Border;
};

struct VS_INPUT {
	float3 pos : POSITION;
	float2 uv  : TEXCOORD0;
};

struct PS_INPUT {
	float4 pos : SV_POSITION;
	float2 uv : TEXCOORD0;
};

// _VF[_
PS_INPUT vsMain( VS_INPUT In ) {
	// [Jʒû܂܃WIgVF[_
	PS_INPUT Out;
	Out.pos = mul( float4( In.pos, 1.0 ), world );
	Out.pos = mul( Out.pos, view );
	Out.pos = mul( Out.pos, proj );
	Out.uv = In.uv;
	return Out;
}

float4 psMain( PS_INPUT In ) : SV_TARGET {
	float4 color = tex.Sample( smp, In.uv );
	return color;
}

RasterizerState rs {
	FillMode = SOLID;
	CullMode = NONE;
	FrontCounterClockWise = FALSE;
	DepthBias = 0;
	DepthBiasClamp = 0;
	SlopeScaledDepthBias = 0;
	DepthClipEnable = FALSE;
	ScissorEnable = FALSE;
	MultiSampleEnable = FALSE;
	AntiAliasedLineEnable = FALSE;
};

BlendState bs {
	AlphaToCoverageEnable = FALSE;
	BlendEnable[0] = FALSE;
	SrcBlend = ONE;
	DestBlend = ZERO;
	BlendOp = REV_SUBTRACT;
	SrcBlendAlpha = ONE;
	DestBlendAlpha = ZERO;
	BlendOpAlpha = ADD;
	RenderTargetWriteMask[0] = 0x0F;
};

DepthStencilState dss {
	DepthEnable = TRUE;
	DepthWriteMask = ALL;
	DepthFunc = LESS;
	StencilEnable = FALSE;
	StencilReadMask = 0xff;
	StencilWriteMask = 0xff;
	FrontFaceStencilFail = KEEP;
	FrontFaceStencilDepthFail = KEEP;
	FrontFaceStencilPass = KEEP;
	FrontFaceStencilFunc = ALWAYS;
	BackFaceStencilFail = KEEP;
	BackFaceStencilDepthFail = KEEP;
	BackFaceStencilPass = KEEP;
	BackFaceStencilFunc = ALWAYS;
};

// eNjbN
technique10 tech {
	pass p0 {
		SetVertexShader( CompileShader( vs_4_0, vsMain() ) );
		SetGeometryShader( NULL );
		SetPixelShader( CompileShader( ps_4_0, psMain() ) );
		
		SetRasterizerState( rs );
		SetBlendState( bs, float4( 0.0f, 0.0f, 0.0f, 0.0f ), 0xFFFFFFFF );
		SetDepthStencilState( dss, 0 );
	}
}
